jQuery(document).ready(function($) {

  changeDropdown();
  allMagazines();
  buttonSpecials();
  changePage();
  flipsnackWrapper();

  // On Dropdown Change
  function changeDropdown() {

    $(".dropdown-menu li a").click(function(){

      $(this).closest(".has-dropdown").find('.btn .text-drop').text($(this).text());
      $(this).closest(".has-dropdown").find('.btn:first-child').val($(this).text());

      $('.r-all').removeClass('active');

      resetPage();
      loadAgain();

    });

  }

  // Click on specials button
  function buttonSpecials() {

    $('.r-specials').on('click',function() {

      if($(this).hasClass('active')) {
        $(this).removeClass('active');
      } else {
        $(this).addClass('active');
      }

      $('.r-all').removeClass('active');

      resetPage();
      loadAgain();

    });

  }


  // Go back to all the magazines
  function allMagazines() {

    $('.r-all').on('click',function() {

      $(this).addClass('active');
      $('.r-specials').removeClass('active');

      $('#dropdownMenuMonth').val('');
      $('#dropdownMenuMonth .text-drop').text('Por mes');
      $('#dropdownMenuYear').val('');
      $('#dropdownMenuYear .text-drop').text('Por año');
      resetPage();

      loadAgain();

    });

  }

  // Page selection
  function changePage() {

    $(document).on('click','.navigation-pag > ul > li > a',function() {

      if( ! $(this).closest('li').hasClass('next-page') && ! $(this).closest('li').hasClass('prev-page') ) {
        $('.navigation-pag > ul > li').removeClass('active');
        $(this).closest('li').addClass('active');


      } else {

        // ADDING OR REDUCING ONE PAGE
        $('.navigation-pag > ul > li').each(function() {
          if($(this).hasClass('active')) {
            currentPos = $(this).find('a').text();
          }
        });

        $('.navigation-pag > ul > li').removeClass('active');
        if( $(this).closest('li').hasClass('next-page') ) {
          currentPos++;
        }
        if( $(this).closest('li').hasClass('prev-page') ) {
          currentPos--;
        }

        $('.navigation-pag > ul > li > a').each(function() {
          if($(this).text()==currentPos) {
            $(this).closest('li').addClass('active');
          }
        });

      }

      loadAgain();


    });

  }

  // It resets the page to the first one (it's require for the moment when the user changes the settings of the filter)
  function resetPage() {

    $('.navigation-pag > ul > li').removeClass('active');
    $('.navigation-pag > ul > li:nth-child(2)').addClass('active');

  }

  // AJAX CALL
  function loadAgain() {

    month = $('#dropdownMenuMonth').val();
    year = $('#dropdownMenuYear').val();

    if($('.r-specials').hasClass('active')) {
      special = true;
    } else {
      special = false;
    }

    $('.navigation-pag > ul > li').each(function() {
      if($(this).hasClass('active')) {
        paged = $(this).find('a').text();
      }
    });

    if($('.r-all').hasClass('active')) {
      all = true;
    } else {
      all = false;
    }

    var data = {
      action: 'show_results',
      security : M_Filter.security,
      month: month,
      year: year,
      special: special,
      all: all,
      paged: paged,
      postid: M_Filter.postid
    };

    jQuery.ajax({
        type: "POST",
        url: M_Filter.ajaxurl,
        dataType: "html",
        data: data,
        beforeSend: function(){
            jQuery('.mf-loader').css({'display':'block'}).animate({'opacity':1});
        },
        success: function(msg) {

          // No results
          if(msg=="no") {

            $('.mf-area').fadeOut('slow', function() {
              $('.mf-area').empty();
              $('.mf-area').append("No hay resultados");
              $('.mf-area').fadeIn("slow",function() {
                $('html,body').animate({
                scrollTop: $(".up-pagination").offset().top},
                'slow');
              });
            });

          } else { // There are results

            $('.mf-area').fadeOut('slow', function() {
              $('.mf-area').empty();
              $('.mf-area').append(msg);
              $('.mf-area').fadeIn("slow",function() {
                $('html,body').animate({
                scrollTop: $(".up-pagination").offset().top-138},
                'slow');
              });
            });

          }

        },
        error: function(msg) {
          console.log(msg);
        },
        complete: function(){
            jQuery('.mf-loader').animate({'opacity':0}).delay("slow").css({'display':'none'});
        }
    });

  }


});

jQuery(window).load(function() {
  setVerticalAlignMagazineText();
});

jQuery(window).resize(function() {
  flipsnackWrapper();
  setVerticalAlignMagazineText();
});

function flipsnackWrapper() {

  var h = jQuery(window).height() * 0.85;
  jQuery('.revista-flipsnack-wrapper').css({'height':h+'px'})

}

function setVerticalAlignMagazineText() {

  if(window.matchMedia('(min-width: 991px)').matches) {
    var textHeight = jQuery('.featured_magazines .right').height();
    var imgHeight = jQuery('.featured_magazines .left img').height();

    var mt = (imgHeight/2)-(textHeight/2);

    jQuery('.featured_magazines .right').css({'margin-top':mt+'px'});
  } else {
    jQuery('.featured_magazines .right').css({'margin-top':'30px'});
  }
}
